#################################################################
###3̓XNvg
###{XNvg̓mF͈ȉ̒ʂł
###R3.0.2(64bit)
###pbP[Wlavaan0.5-15
###pbP[WsemPlot0.3.3
#################################################################

#pbP[W̓ǂݍ
library(lavaan)
library(semPlot)

###1߁@pX
#f
#f[^̓ǂݍ
#x1FwCx2FN, x3FEƈАMCx4F]
data1 <- read.csv("dat/marriage.csv")
head(data1)
#f̎w
model1 <- 'x3 ~ x1 + x2
           x4 ~ x2 + x3'
#͂̎s
fit1 <- sem(model1, data=data1)
#͌ʂ̊mF
summary(fit1, standardized=T, fit.measures=T)
#standardizedSolution(fit01)

#pX}̕`(iK)F}3.2
semPaths(fit1, whatLabels ="stand",
layout="tree", style="lisrel", nCharNodes=0,
sizeMan=15, edge.label.cex=2.0)
#pX}̕`(iK)F}3.3
semPaths(fit1, whatLabels="stand",
layout="tree",style="lisrel",sizeMan=15,
edge.label.cex=2.0,rotation=2,reorder=F, 
manifests=c("x2","x1","x4","x3"),
nodeLabels=c("E","w","]","N"))

#񒀎f
data2 <- read.csv("dat/fan.csv")
model2 <- ' x3 ~ x1 + x4
            x4 ~ x2 + x3'
fit2 <- sem(model2, data=data2)
#fit02_2 <- sem(model02, data=data02, fixed.x=F,std.lv=T)
summary(fit2, standardized=T, fit.measures=T)
#summary(fit02_2, standardized=T, fit.measures=T)

#pX}̕`F}3.4
semPaths(fit2, whatLabels="stand", 
style= "lisrel",layout="spring",
sizeMan=15,edge.label.cex=2.0,
nCharNodes=0,curve=1.5,mar=c(7,7,7,3),
manifest=c("x1","x3","x2","x4"),
nodeLabels=c("v̕","v","Ȃ̕",""))


###3߁@ϗʉA
#Α֌W̗
data3_1 <- read.csv("dat/stats.csv", row.names=1)
round(cor(data3_1),3) #֍švZ
mean(data3_1$x); mean(data3_1$y); mean(data3_1$z) #eϐ̕
sd(data3_1$x)*46/47; sd(data3_1$y)*46/47; sd(data3_1$z)*46/47 #eϐ̕W΍
round((0.648-0.695*0.885)/(sqrt(1-0.695^2)*sqrt(1-0.885^2)), 3) #Αւ̌vZ

#ϗʉA̓fɂΑ֌W̋ߕ
model3_1 <- ' x ~ z
              y ~ z  '
fit3_1<-sem(model3_1,data=data3_1)
summary(fit3_1,standardized=T,fit.measures=T)

#pX}̕`F}3.5
semPaths(fit3_1,whatLabels="stand",
layout="tree",style="lisrel",
edge.color="black",shapeMan="rectangle",
sizeMan=15,sizeMan2=10,residScale=10,
edge.label.cex=2.5,nDigits=3)

#uf[^v̕
#xF yF z1Fm\ z2F׋
lower <- '1.000
          0.020 1.000
          0.004 0.791 1.000
         -0.423 0.722 0.341 1.000'
full <- getCov(lower, 
             names=c("x","y","z1","z2"))
model3_2 <- ' x ~ z1 + z2
              y ~ z1 + z2'
fit3_2<-sem(model3_2,sample.cov=full,
      sample.nobs=280, fixed.x=FALSE)
summary(fit3_2, standardized=T, fit.measures=T)
semPaths(fit3_2, whatLabels="stand",
layout="tree2",style="lisrel",
edge.color="black",sizeMan=10,
edge.label.cex=2.0,nDigits=3)


###4߁@MMIC/PLS
data4 <- read.csv("dat/semidata.csv")
#MIMICf
model4_MIMIC <- ' f2 ~ x1 + x2 + x3 + x4
                  f2 =~ x5 + x6 + x7'
fit4_M <- sem(model4_MIMIC,data=data4,fixed.x=F)
summary(fit4_M, standardized=T, fit.measures=T)

#pX}̕`F}3.6
semPaths(fit4_M, whatLabels="stand",
layout="tree",style="lisrel",
shapeLat="ellipse",sizeMan=9,sizeLat=10,
sizeLat2=7,rotation=2,edge.label.cex=1.6,
curve=2,curvePivot=F,residScale=15,
manifests=c("x4","x3","x2","x1","x7","x6","x5"))

#PLSf
model4_PLS <- ' f1 ~ x1 + x2 + x3 + x4
                 f2 =~ x5 + x6 + x7
                 f1 =~ f2
                 f1 ~~ 0*f1
                 f2~~f2'
fit4_P <- sem(model4_PLS, data=data4, fixed.x=F)
summary(fit4_P, standardized=T, fit.measures=T)

#pX}̕`F}3.7
semPaths(fit4_P, whatLabels="stand",
layout="tree",style="lisrel",
shapeLat="ellipse",optimizeLatRes=T, 
sizeMan=7,sizeLat=9,sizeLat2=7,
rotation=2,edge.label.cex=1.3,
curve=2,curvePivot=F,residScale=12,
manifests=c("x4","x3","x2","x1","x7","x6","x5"))

###5߁@EKwq̓f
data5 <- read.csv("dat/intelligence.csv")
#2q̓f
model5_S<- 'of1 =~ x1 + x2 + x3
            f2 =~ x4 + x5 + x6
            xf3 =~ x7 + x8 + x9
            m\ =~ of1 + f2 + xf3'
fit5_S <- sem(model5_S, std.lv=TRUE, data=data5)
summary(fit5_S, fit.measures=T, standardized=T)

#pX}̕`F}3.8
semPaths(fit5_S,layout="tree",whatLabels="stand", 
edge.color="black",sizeMan=7, edge.label.cex=0.9,
shapeLat="ellipse",sizeLat=8, sizeLat2=5,
style="lisrel", optimizeLatRes=T, nCharNodes=0)

#Kwq̓f
model5_H <- 'of1 =~ x1 + x2 + x3
             f2 =~ x4 + x5 + x6
             xf3 =~ x7 + x8 + x9
             F =~ x1 + x2 + x3 + x4 + x5 + x6 +x7 + x8 + x9
             F ~~ 0*of1 + 0*f2 + 0*xf3
             x3 ~~ a*x3; a>0'
fit5_H <- sem(model5_H, std.lv=T, data=data5)
summary(fit5_H,fit.measures=T,standardized=T)

#pX}̕`F}3.9
semPaths(fit5_H,layout="spring",
whatLabels="stand",sizeMan=5,
shapeLat="ellipse",sizeLat=8,sizeLat2=5,
exoCov=F,residuals=F,nCharNodes=0,
edge.label.cex=0.9,edge.color="black")


###6߁@1q̓fɂM
data6 <- read.csv("dat/extra.csv")
model6 <- ' O =~ x1 + x2 + x3 + x4 + x5 '
fit6 <- sem(model6, data=data6, std.lv=T)
summary(fit6, fit.measures=T) 

#pX}̕`F}3.10
semPaths(fit6,layout="tree",style="ram",
whatLabels="est",nCharNodes=0,sizeMan=10,
shapeLat="ellipse",sizeLat=15,sizeLat2=10,
edge.label.cex=1.5,edge.color="black")

##֌W
a <- (0.99+1.17+0.77+1.01+0.69)^2 #qׂ̘a2
e <- 1.68+1.21+1.23+1.11+1.31 #덷U̘a
round(a/(a+e), 3) #֌W̎Zo
##W
(var.mat <- var(data6)*(nrow(data6)+1)/nrow(data6)) #Us
#eڂ̕U̍v
sum.var <- var.mat[1,1]+var.mat[2,2]+var.mat[3,3]+var.mat[4,4]+var.mat[5,5]
#v_̕U
all.var <- sum.var + 2*(var.mat[1,2]+var.mat[1,3]+var.mat[1,4]+var.mat[1,5]
 +var.mat[2,3]+var.mat[2,4]+var.mat[2,5]+var.mat[3,4]+var.mat[3,5]+var.mat[4,5])
round(5/4*(1-(sum.var/all.var)), 3) #W̎Zo

##ȉs邱ƂɂĂ֌WƃW߂邱Ƃł
#ڍׂɂĂ͑9͎QƂ̂
library(semTools)
reliability(fit6)

###7߁@MTMM
lower.MTMM <- '1.000
               0.464 1.000
               0.340 0.223 1.000
               0.574 0.241 0.330 1.000
               0.349 0.762 0.195 0.300 1.000
               0.175 0.019 0.646 0.390 0.119 1.000
               0.639 0.346 0.309 0.630 0.326 0.281 1.000
               0.399 0.788 0.166 0.251 0.791 0.052 0.420 1.000
               0.276 0.121 0.657 0.282 0.143 0.692 0.445 0.237 1.000'
full.MTMM <- getCov(lower.MTMM, 
         names=c("x11","x21","x31","x12","x22","x32","x13","x23","x33"))
model7 <- ' T1 =~ x11 + x12 + x13
            T2 =~ x21 + x22 + x23
            T3 =~ x31 + x32 + x33
            M1 =~ x11 + x21 + x31
            M2 =~ x12 + x22 + x32
            M3 =~ x13 + x23 + x33 
            T1 ~~ 0*M1 + 0*M2 + 0*M3
            T2 ~~ 0*M1 + 0*M2 + 0*M3
            T3 ~~ 0*M1 + 0*M2 + 0*M3
            M1 ~~ 0*M2 + 0*M3
            M2 ~~ 0*M3'
fit7 <- sem(model7, sample.cov=full.MTMM, sample.nobs=406,std.lv=T)
summary(fit7, fit.measures=T, standardized=T)

#pX}̕`F}3.11
semPaths(fit7,what="path",whatLabels="no",
style="lisrel",layout="tree",sizeMan=6,
curve=1.5,curvePivot=F,freeStyle=c("black",1),
fixedStyle=c("white",0))

###8߁@\TOԂ̈ʃf
lower.cov <- '0.54
              0.99 2.28
              0.82 1.81 1.98
              0.73 1.27 0.91 6.89
              0.62 1.49 1.17 6.25 15.58
              0.79 1.55 1.04 5.84 5.84 10.76
              1.08 2.06 1.58 5.06 5.60 4.94 6.83
              0.85 1.81 1.57 5.75 9.39 4.73 4.98 11.38
              0.94 2.00 1.63 5.81 7.54 7.01 5.82 6.75 10.80'
full.cov <- getCov(lower.cov, 
         names=c("x1","x2","x3","x4","x5","x6","x7","x8","x9"))

model8 <- ' f1 =~ x1+x2+x3
            f2 =~ x4+a*x5+b*x6
            f3 =~ x7+a*x8+b*x9
            f2 ~ f1
            f3 ~ f1+f2
            x4 ~~  c*x4 + x7
            x5 ~~  d*x5 + x8
            x6 ~~  e*x6 + x9
            x7 ~~  c*x7
            x8 ~~  d*x8
            x9 ~~  e*x9 '
fit8 <- sem(model8, sample.cov=full.cov, sample.nobs=75)
summary(fit8,fit.measures=T,standardized=T)

#pX}̕`F}3.12
semPaths(fit8,layout="tree",whatLabels="est", 
style="lisrel",sizeMan=7,sizeLat=10,sizeLat2=8,
edge.color="black",curve=1,curvePivot=F,edge.label.cex=1.2)


###H̉
##H1
lower.ex1  <- '
1.00
 .56 1.00
 .06  .05 1.00
 .16  .21  .32 1.00
 .01 -.04  .10 -.06 1.00
-.07 -.05  .16 -.07  .42 1.00
-.02 -.01  .14  .08  .18  .31 1.00
 .17  .30  .29  .40  .01  .13  .21 1.00
 .16  .21  .28  .19  .12  .27  .27  .50 1.00
 .05  .04  .08  .13  .07  .15  .25  .28  .24 1.00
 .10  .10  .09  .17  .02  .08  .08  .23  .18  .59 1.00
 .10  .17  .14  .17  .08  .17  .33  .32  .40  .55  .49 1.00
'
full.ex1 <- getCov(lower.ex1, 
names=c( "x01","x02","x03","x04","x05","x06","x07","x08","x09","x10","x11","x12"))

#f̎wi}3.13j
model.ex1 <- ' f1 =~  x01 + x02
               f2 =~  x03 + x04
               f3 =~  x05 + x06 + x07
               f4 =~  x08 + x09
               f5 =~  x10 + x11 + x12
               f4 ~ f1 + f2 + f5
               f5 ~ f3 + f4'
#͂̎sƌʂ̏ói}3.13j
fit.ex1 <- sem(model.ex1,
  sample.cov=full.ex1,sample.nobs=249)
summary(fit.ex1,standardized=T)

#pX}`̂߂̃XNvg̗Ⴛ1i}3.13j
semPaths(fit.ex1,layout="circle",what="path",
whatlabels="no",sizeLat=5, style="lisrel",
curve=1,residScale=6,edge.label.cex=0.7)
#pX}`̂߂̃XNvg̗Ⴛ2i}3.13j
semPaths(fit.ex1,layout="tree",
what="path", whatlabels="no",sizeLat=5,
style="lisrel",curvePivot=F, curve=1.5, rotation=2,
reorder=F, latents=c("f3","f2","f1","f5","f4"),
manifests=c("x07","x06","x05","x04","x03","x02","x01","x12","x11","x10","x09","x08"),
residScale=6,edge.label.cex=0.7)

##H2
lower.ex2  <- '
1.000
0.610 1.000
0.422 0.297 1.000
0.268 0.419 0.660 1.000
0.466 0.223 0.400 0.228 1.000
0.221 0.458 0.241 0.412 0.585 1.00
'
full.ex2 <- getCov(lower.ex2, names=c( "x1","x2","x3","x4","x5","x6"))
#f̎wi}3.14j
model.ex2_1 <- ' f1 =~ x1 + x2
                 f2 =~ x3 + x4
                 f3 =~ x5 + x6
                 f2 ~ f1
                 f3 ~ f2'
#͂̎sƌʂ̏ói}3.14j
fit.ex2_1 <- sem(model.ex2_1,
  sample.cov=full.ex2, sample.nobs=100)
summary(fit.ex2_1,standardized=T)
#pX}`̂߂̃XNvg̗i}3.14j
semPaths(fit.ex2_1,layout="tree",
whatLabels="stand",style="lisrel",
residScale=10)


#f̎wi}3.15j
model.ex2_2 <- ' f1 =~ x1 + x3 + x5
                 f2 =~ x2 + x4 + x6
                 f3 =~ a*x1 + a*x2
                 f4 =~ b*x3 + b*x4
                 f5 =~ c*x5 + c*x6
                 f4 ~ f3
                 f5 ~ f4
                 f3 ~~ 0*f1+0*f2
                 f1 ~~ 0*f2'
#͂̎sƌʂ̏ói}3.15j
fit.ex2_2 <- sem(model.ex2_2,
  sample.cov=full.ex2, sample.nobs=100)
summary(fit.ex2_2,standardized=T)
#pX}`̂߂̃XNvg̗i}3.15j
semPaths(fit.ex2_2,layout="tree2",
whatLabels="stand",style="lisrel",
exoCov=F,reorder=F,
manifests=c("x1","x2","x5","x3","x4","x6"))
