######################################################################
# U\R
# 5́@ϋU\
######################################################################


#########################################################################
# 5.1߁@ϋU\͂Ƃ

# dA
# ϐ
# x1:eLXg, x2:v[, x3:y[X, x4:utΏ, x5:x, x6:x, x7:ړIv

dat <- read.csv("dat/semidata.csv")
glm(x5~x2+x4+x6, data=dat)



# lavaan𗘗pdA
library(lavaan); library(semPlot)

# ϐ
# x1:eLXg, x2:v[, x3:y[X, x4:utΏ, x5:x, x6:x, x7:ړIv
# dAf
model <- '
  x5 ~ 1 + x2 + x4 + x6
  x5 ~~ x5
'

fit <- lavaan(model, data=dat)
summary(fit)




#########################################################################
# 5.2߁@ύ\̂pX
# library(lavaan)

# ϑϐ݂̂̏ꍇ
# ϐ
# x1:eLXg, x2:v[, x3:y[X, x4:utΏ, x5:x, x6:x, x7:ړIv

# pX̓f
model <- '
x6 ~ 1 + x2 + x4
x5 ~ 1 + x2 + x4 + x6
x5 ~~ x5; x6 ~~ x6
'

fit <- lavaan(model, data=dat)
summary(fit)

2.04 + 0.23*mean(dat$x2) + 0.11*mean(dat$x4)



# \TOԂ̃pX
# ϐ
# x1:eLXg, x2:v[, x3:y[X, x4:utΏ, x5:x, x6:x, x7:ړIv

# pX̓f
model <- '
f1 =~ x1 + x2 + x3 + 1*x4 
x1 + x2 + x3 + x4 ~ 0*1
x1 ~~ x1; x2 ~~ x2; x3 ~~ x3; x4 ~~ x4
f1 ~ 1
f1 ~~ f1

f2 =~ x5 + x6 + 1*x7
x5 + x6 + x7 ~ 0*1
x5 ~~ x5; x6 ~~ x6; x7 ~~ x7
f2 ~~ f2

f2 ~ 1 + f1
'

fit <- lavaan(model, data=dat)
summary(fit, standardized=T, fit.measure=T)
semPaths(fit, optimizeLatRes=T, whatLabels="est")




#################################################
# 5.3߁@cff[^̈q1
# gpf[^

dat <- read.table("dat/IQtest.csv", sep=",", header=T, row.names=1)
dat <- as.matrix(dat)

IQ.cov <- dat[1:8,]
IQ.mean <- dat[9,]

rownames(IQ.cov) <- colnames(IQ.cov)




#################################################
# 5.4߁@cff[^̈q2

# ϐ
# V1:Hi1j, V2:́i1j, V3:􉽐}`i1j, V4:ٕٓʁi1j
# V5:Hi1j, V6:́i1j, V7:􉽐}`i1j, V8:ٕٓʁi1j

########################################################################
########################################################################
# f1Fzusσf
model <- '
f1 =~ V1 + V2 + V3 + V4
f1 ~ 0*1; 
f1 ~~ 1*f1

f2 =~ V5 + V6 + V7 + V8
f2 ~ 0*1; 
f2 ~~ 1*f2

f1 ~~ f2
V1 ~~ V5; V2 ~~ V6; V3 ~~ V7; V4 ~~ V8

V1 + V2 + V3 + V4 ~ 1
V5 + V6 + V7 + V8 ~ 1

V1 ~~ V1; V2 ~~ V2; V3 ~~ V3; V4 ~~ V4
V5 ~~ V5; V6 ~~ V6; V7 ~~ V7; V8 ~~ V8
'

fit <- lavaan(model, sample.cov=IQ.cov, sample.mean=IQ.mean, sample.nobs=1472)
summary(fit, standardized=T, fit.measure=T)
semPaths(fit, optimizeLatRes=T, whatLabels="est")



########################################################################
########################################################################
# f2F㑪sσf
model <- '
f1 =~ a1*V1 + a2*V2 + a3*V3 + a4*V4
f1 ~ 0*1; 
f1 ~~ 1*f1

f2 =~ a1*V5 + a2*V6 + a3*V7 + a4*V8
f2 ~ 0*1; 
f2 ~~ f2

f1 ~~ f2
V1 ~~ V5; V2 ~~ V6; V3 ~~ V7; V4 ~~ V8

V1 + V2 + V3 + V4 ~ 1
V5 + V6 + V7 + V8 ~ 1

V1 ~~ V1; V2 ~~ V2; V3 ~~ V3; V4 ~~ V4
V5 ~~ V5; V6 ~~ V6; V7 ~~ V7; V8 ~~ V8
'

fit <- lavaan(model, sample.cov=IQ.cov, sample.mean=IQ.mean, sample.nobs=1472)
summary(fit, standardized=T, fit.measure=T)
semPaths(fit, optimizeLatRes=T, whatLabels="est")



########################################################################
########################################################################
# f3Fsσf
model <- '
f1 =~ a1*V1 + a2*V2 + a3*V3 + a4*V4
f1 ~ 0*1; 
f1 ~~ 1*f1

f2 =~ a1*V5 + a2*V6 + a3*V7 + a4*V8
f2 ~ 1; 
f2 ~~ f2

f1 ~~ f2
V1 ~~ V5; V2 ~~ V6; V3 ~~ V7; V4 ~~ V8

V1 + V5 ~ b1*1
V2 + V6 ~ b2*1
V3 + V7 ~ b3*1
V4 + V8 ~ b4*1

V1 ~~ V1; V2 ~~ V2; V3 ~~ V3; V4 ~~ V4
V5 ~~ V5; V6 ~~ V6; V7 ~~ V7; V8 ~~ V8
'

fit <- lavaan(model, sample.cov=IQ.cov, sample.mean=IQ.mean, sample.nobs=1472)
summary(fit, standardized=T, fit.measure=T)
semPaths(fit, optimizeLatRes=T, whatLabels="est")




########################################################################
########################################################################
# f4Fȑsσf
model <- '
f1 =~ a1*V1 + a2*V2 + a3*V3 + a4*V4
f1 ~ 0*1; 
f1 ~~ 1*f1

f2 =~ a1*V5 + a2*V6 + a3*V7 + a4*V8
f2 ~ 1; 
f2 ~~ f2

f1 ~~ f2
V1 ~~ V5; V2 ~~ V6; V3 ~~ V7; V4 ~~ V8

V1 + V5 ~ b1*1
V2 + V6 ~ b2*1
V3 + V7 ~ b3*1
V4 + V8 ~ b4*1

V1 ~~ c1*V1
V2 ~~ c2*V2
V3 ~~ c3*V3
V4 ~~ c4*V4
V5 ~~ c1*V5
V6 ~~ c2*V6
V7 ~~ c3*V7
V8 ~~ c4*V8
'

fit <- lavaan(model, sample.cov=IQ.cov, sample.mean=IQ.mean, sample.nobs=1472)
summary(fit, standardized=T, fit.measure=T)
semPaths(fit, optimizeLatRes=T, whatLabels="est")




########################################################################
########################################################################
# f5FSꐔf
model <- '
f1 =~ a1*V1 + a2*V2 + a3*V3 + a4*V4
f1 ~ 0*1; 
f1 ~~ 1*f1

f2 =~ a1*V5 + a2*V6 + a3*V7 + a4*V8
f2 ~ 0*1; 
f2 ~~ f2

f1 ~~ f2
V1 ~~ V5; V2 ~~ V6; V3 ~~ V7; V4 ~~ V8

V1 + V5 ~ b1*1
V2 + V6 ~ b2*1
V3 + V7 ~ b3*1
V4 + V8 ~ b4*1

V1 ~~ c1*V1
V2 ~~ c2*V2
V3 ~~ c3*V3
V4 ~~ c4*V4
V5 ~~ c1*V5
V6 ~~ c2*V6
V7 ~~ c3*V7
V8 ~~ c4*V8
'

fit <- lavaan(model, sample.cov=IQ.cov, sample.mean=IQ.mean, sample.nobs=1472)
summary(fit, standardized=T, fit.measure=T)
semPaths(fit, optimizeLatRes=T, whatLabels="est")








#################################################
# 5.5߁@cff[^̈q3

# ϐ
# V1:Hi1j, V2:́i1j, V3:􉽐}`i1j, V4:ٕٓʁi1j
# V5:Hi1j, V6:́i1j, V7:􉽐}`i1j, V8:ٕٓʁi1j


# fr
library(semTools)

model <- '
f1 =~ V1 + V2 + V3 + V4
f2 =~ V5 + V6 + V7 + V8
'

# ϐQ̎w
time1 <- c("V1", "V2", "V3", "V4")
time2 <- c("V5", "V6", "V7", "V8")
constrainedVar <- list(time1, time2)

longInvariance(model, sample.cov=IQ.cov, sample.mean=IQ.mean, sample.nobs=1472,
               auto=1, constrainAuto=F, varList=constrainedVar, strict=T)



# ͂̎s(ȑsσf)
model <- '
# 㑪s
f1 =~ a1*V1 + a2*V2 + a3*V3 + a4*V4
f1 ~ 0*1; f1 ~~ 1*f1

f2 =~ a1*V5 + a2*V6 + a3*V7 + a4*V8
f2 ~ 1; f2 ~~ f2

f1 ~~ f2
V1 ~~ V5; V2 ~~ V6; V3 ~~ V7; V4 ~~ V8

# s
V1 + V5 ~ b1*1
V2 + V6 ~ b2*1
V3 + V7 ~ b3*1
V4 + V8 ~ b4*1

# ȑs
V1 ~~ c1*V1
V2 ~~ c2*V2
V3 ~~ c3*V3
V4 ~~ c4*V4
V5 ~~ c1*V5
V6 ~~ c2*V6
V7 ~~ c3*V7
V8 ~~ c4*V8
'

fit <- lavaan(model, sample.cov=IQ.cov, sample.mean=IQ.mean, sample.nobs=1472)
summary(fit, standardized=T, fit.measure=T)
semPaths(fit, optimizeLatRes=T, whatLabels="est")


























