# U\R
# 6́@Wc

# w[ړx
# ϐ
# F1:ݐЉے, F2:ݐДN, F3:T[N, F4:N, F5:
# V41:肽Ƃ
# V42:̎ɎM
# V43:wɍŝy
# V44:̐Ƀn
# V45:w͂Ă邱Ƃ
# V46:͉l̂w𑗂ĂƎv
# V47:wƂĂ̎Dł
# V48:Ɍւ肪
# V49:lɂĐ^ʖڂɍlĂ


library(semTools); library(semPlot)


###########################################################################
# 6.2߁@l
dat <- read.csv("dat/collegelife.csv")


###########################################################################
###########################################################################
# f1Fzusσf
model <- '
# {f
f1 =~ V1 + V2 + V3 + V4
V1 +  V2  +  V3  +  V4 ~ 1
V1 ~~ V1; V2 ~~ V2; V3 ~~ V3; V4 ~~ V4

# qςƈq̕U1ɌŒ肷
f1 ~ c(fm11, fm21)*1
fm11 == 0; fm21 == 0

f1 ~~ c(fv11, fv21)*f1
fv11 == 1; fv21 == 1
'

fit <- lavaan(model, data=dat, group="C")

summary(fit, standardized=T, fit.measure=T)
semPaths(fit, optimizeLatRes=T, whatLabels="est")



###########################################################################
###########################################################################
# f2F㑪sσf
model <- '
# {f
f1 =~ V1 + V2 + V3 + V4
V1 +  V2  +  V3  +  V4 ~ 1
V1 ~~ V1; V2 ~~ V2; V3 ~~ V3; V4 ~~ V4

# qςƈq̕U1ɌŒ肷
f1 ~ c(fm11, fm21)*1
fm11 == 0; fm21 == 0

f1 ~~ c(fv11, fv21)*f1
fv11 == 1
'

fit <- lavaan(model, data=dat, group="C", 
              group.equal=c("loadings"))

summary(fit, standardized=T, fit.measure=T)
semPaths(fit, optimizeLatRes=T, whatLabels="est")



###########################################################################
###########################################################################
# f3Fsσf
model <- '
# {f
f1 =~ V1 + V2 + V3 + V4
V1 +  V2  +  V3  +  V4 ~ 1
V1 ~~ V1; V2 ~~ V2; V3 ~~ V3; V4 ~~ V4

# qςƈq̕U1ɌŒ肷
f1 ~ c(fm11, fm21)*1
fm11 == 0

f1 ~~ c(fv11, fv21)*f1
fv11 == 1
'

fit <- lavaan(model, data=dat, group="C", 
              group.equal=c("loadings", "intercepts"))

summary(fit, standardized=T, fit.measure=T)
semPaths(fit, optimizeLatRes=T, whatLabels="est")



###########################################################################
###########################################################################
# f4Fȑsσf
model <- '
# {f
f1 =~ V1 + V2 + V3 + V4
V1 +  V2  +  V3  +  V4 ~ 1
V1 ~~ V1; V2 ~~ V2; V3 ~~ V3; V4 ~~ V4

# qςƈq̕U1ɌŒ肷
f1 ~ c(fm11, fm21)*1
fm11 == 0

f1 ~~ c(fv11, fv21)*f1
fv11 == 1
'

fit <- lavaan(model, data=dat, group="C", 
              group.equal=c("loadings", "intercepts", "residuals"))

summary(fit, standardized=T, fit.measure=T)
semPaths(fit, optimizeLatRes=T, whatLabels="est")



###########################################################################
###########################################################################
# f5FSꐔf
model <- '
# {f
f1 =~ V1 + V2 + V3 + V4
V1 +  V2  +  V3  +  V4 ~ 1
V1 ~~ V1; V2 ~~ V2; V3 ~~ V3; V4 ~~ V4

# q̕U1ɌŒ肷
f1 ~~ c(fv11, fv21)*f1
fv11 == 1
'

fit <- lavaan(model, data=dat, group="C", 
              group.equal=c("loadings", "intercepts", "residuals", "means"))

summary(fit, standardized=T, fit.measure=T)
semPaths(fit, optimizeLatRes=T, whatLabels="est")






###########################################################################
# 6.3߁@1qf͗̕

# fr
model <- '
f1 =~ V1 + V2 + V3 + V4
'

out <- measurementInvariance(model, data=dat, group="C", strict=T, quiet=T)
compareFit(out)


# ꐔ̐
model <- '
# {f
f1 =~ V1 + V2 + V3 + V4
V1 +  V2  +  V3  +  V4 ~ 1
V1 ~~ V1; V2 ~~ V2; V3 ~~ V3; V4 ~~ V4

# Wc1̈q̕U1ɌŒ肷
f1 ~~ c(fv11, fv21)*f1
fv11 == 1
'

fit <- lavaan(model, data=dat, group="C", 
              group.equal=c("loadings","intercepts","residuals","means"))

summary(fit, standardized=T, fit.measure=T)
semPaths(fit, optimizeLatRes=T, whatLabels="est")




##########################################################
# 6.4߁@2qf͗̕

# fr
model <- '
f1 =~ V1 + V2 + V3 + V4
f2 =~ V5 + V6 + V7 + V8
f1 ~ f2
'

out <- measurementInvariance(model, data=dat, group="C", strict=T, quiet=T)
compareFit(out)


# ꐔ̐
model <- '
# {f
f1 =~ V1 + V2 + V3 + V4
V1 + V2 + V3 + V4 ~ 1
V1 ~~ V1; V2 ~~ V2; V3 ~~ V3; V4 ~~ V4
f1 ~~ c(fv11, fv21)*f1

f2 =~ V5 + V6 + V7 + V8
V5 + V6 + V7 + V8 ~ 1
V5 ~~ V5; V6 ~~ V6; V7 ~~ V7; V8 ~~ V8
f2 ~ c(fm12, fm22)*1
f2 ~~ c(fv12, fv22)*f2

f1 ~ 1 + f2

# qςƈq̕U1ɌŒ肷
fm12 == 0
fv11 == 1; fv12 == 1; fv22 == 1
'

fit <- lavaan(model, data=dat, group="C", 
              group.equal=c("loadings","intercepts"))

summary(fit, standardized=T, fit.measure=T)
semPaths(fit, optimizeLatRes=T, whatLabels="est")




##############################################################
# 6.5߁@Us񂩂̕
# bwKf[^Ɋւ铝QƎQ̔r

# Q
varnames<- c("V1","V2","V3","V4")
lower1  <- '
37.626
24.933 34.680
26.639 24.236 32.013
23.649 27.760 23.565 33.443
'
full1.cov <- getCov(lower1, names=varnames)
means1<-c(18.381, 20.229, 20.400, 21.343)

# Q
lower2  <- '
50.084
42.373 49.872
40.760 36.094 51.237
37.343 40.396 39.890 53.641
'
full2.cov <- getCov(lower2, names=varnames)
means2<-c(20.556, 21.241, 25.667, 25.870)


# f[^̃Xg쐬
N<-list(Q=105, Q=108)
full<-list(Q=full1.cov, Q=full2.cov)
means<-list(Q=means1, Q=means2)


# ꐔ
model <- '
# {f
f1 =~ V1 + V2
V1 ~ c1*1; V2 ~ c2*1
V1 ~~ V1; V2 ~~ V2
f1 ~ c(fm11, fm21)*1
f1 ~~ 1*f1

f2 =~ V3 + V4
V3 ~ c1*1; V4 ~ c2*1
V3 ~~ V3; V4 ~~ V4
f2 ~~ c(fv12, fv22)*f2

f2 ~ 1 + c(a1,a1)*f1

# qςƈq̕U1ɌŒ肷
fm11 == 0
fv12 == 1

V2 ~~ V4
'

fit <- lavaan(model, sample.cov=full, sample.mean=means, sample.nobs=N, 
              group.equal=c("loadings","intercepts"))

summary(fit, standardized=T, fit.measure=T)
semPaths(fit, optimizeLatRes=T, whatLabels="est")




