#######  10  ###########
#######################################################################
library(lavaan.survey)
#f[^̓ǂݍ
mat <- read.csv("dat/mat.csv")
head(mat)

#o@̎w
svy.design <- svydesign(ids=~school + student, fpc=~M + N.m, 
weights=~w, data=mat)

library(lavaan)
#f̎w
model <-'test~1 + motive'

#lavaan ̎s
lavaan.fit <- lavaan(model, data=mat, auto.var=TRUE,estimator="MLM")

survey.fit <- lavaan.survey(lavaan.fit=lavaan.fit, 
survey.design=svy.design)

#Kw\lꍇ
parameterEstimates(lavaan.fit)
#Kw\𖳎ꍇ
parameterEstimates(survey.fit)
#######################################################################


