library(lavaan)
testscore<-read.csv("dat/chapter11.csv")
#fݒ
boot.model<-'
 f1 =~ eng1 + lit1 + mth1 + soc1
 f2 =~ eng2 + lit2 + mth2 + soc2
 f2 ~ f1; eng1 ~~ eng2; lit1 ~~ lit2
 mth1 ~~ mth2; soc1 ~~ soc2 '
#ʏ̃fɂ鐄
boot.result.1<-sem(boot.model,
 data=testscore)
summary(boot.result.1,fit.measures=TRUE)

#u[gXgbvW덷̐
set.seed(1234)
boot.result.2<-sem(boot.model,
 data=testscore, se="bootstrap",
 bootstrap = 1000)
summary(boot.result.2,fit.measures=TRUE)

#u[gXgbvMԂ̐(Efroñp[Z^C@)
boot.result.3<-parameterEstimates(
 boot.result.2,boot.ci.type = "perc")
boot.result.3

#u[gXgbvMԂ̐(Kߎ@)
boot.result.4<-parameterEstimates(
 boot.result.2,boot.ci.type = "norm")
boot.result.4

#u[gXgbv@ɂX̐l̎Zo
set.seed(1234)
boot.result.5<-bootstrapLavaan(
 boot.result.1)
summary(boot.result.5)

#Cꂽu[gXgbv@ɂKx̕]
set.seed(1234)
boot.result.6<-bootstrapLavaan(
 boot.result.1,type="bollen.stine",
 FUN="fitMeasures")
summary(boot.result.6)