#}9.1̕`
##################################################
alpha <- 0.05
xlabel <- "chi-squared"	
curve(dchisq(x,df=20,0),0, 100,ylab="mx",
xlab=xlabel,ylim=c(0,0.08))
par(new=T)	
curve(dchisq(x,df=20,30),0, 100,ylab="",
xlab=xlabel,ylim=c(0,0.08))

crit <- qchisq(0.95,20,0)
xvals <- seq(crit,100)	
br <- length(xvals)

dvals <- dchisq(xvals,df=20,30)  # ΉOt̍
polygon(c(xvals,rev(xvals)),c(rep(0,br),rev(dvals)),
yaxt="n",ylab="",col="grey") 
abline(h=0)
##################################################

#RMSEA̕W{zƃJC敪z̕`
#pbP[WsemToolsANeBuɂ
library(semTools)

#RMESA2w
epsilon <- c(0.00,0.08)
#W{200
nobs <- 200 
#fRx22
d <- 22 
#RMSEA=0.00̕z95p[ZgNɐ
p <- 0.95 
#}̖}쐬
label <- paste("RMSEA=",epsilon,sep="")

#JC敪z`
plotRMSEAdist(rmsea=epsilon,n=nobs,
df=d,ptile=p,caption=label,
rmseaScale=FALSE)
##############################################

#JC敪z̕`
##############################################
#RMESA2w
epsilon <- c(0.00,0.05)
#W{100
nobs <- 100
#fRx300
d <- 30
#RMSEA=0.00̕z99p[ZgNɐ
p <- 0.99 
#}̖}쐬
label <- paste("RMSEA=",epsilon,sep="")

#JC敪z`
plotRMSEAdist(rmsea=epsilon,n=nobs,
df=d,ptile=p,caption=label,
rmseaScale=FALSE)
##############################################

#exact fitɂ錟͂̎Zo
##############################################
#ARMSEA
epsilon0 <- 0.00
#ΗRMSEA
epsilonA <- 0.05
#W{
nobs <- 100
#f̎Rx
d <- 30
#LӐ
a <- 0.05

#͂̎Zo
findRMSEApower(rmsea0=epsilon0,rmseaA=epsilonA,
n=nobs,df=d,alpha=a)
###############################################

#lXȋAɂ錟͂̎Zo
###############################################
#close fit
epsilon0 <- 0.05
epsilonA <- 0.10

#͂̎Zo
findRMSEApower(rmsea0=epsilon0,
rmseaA=epsilonA, n=nobs,df=d, alpha=a)

#not-close fit
epsilon0 <- 0.05
epsilonA <- 0.01
#͂̎Zo
findRMSEApower(rmsea0=epsilon0,
rmseaA=epsilonA, n=nobs,df=d, alpha=a)
###############################################

#W{̎Zo
###############################################
epsilon0 <- 0.05
epsilonA <- 0.01
pow <- 0.8
a <- 0.05
d <- 30
findRMSEAsamplesize(rmsea0=epsilon0,
rmseaA=epsilonA,df=d,power=pow,alpha=a)
###############################################

#͊֐̕`
###############################################
library(semTools)

#W{̉̎w
nl <-50
#W{̏̎w
nh <- 600

plotRMSEApower(rmsea0=epsilon0,
rmseaA=epsilonA, df=d, nlow=nl, 
nhigh=nh, alpha=a)
##############################################

#lXgf͕̌
##############################################
library(semTools)
#fAɂA
epsilon0A <- 0.00
#fBɂA
epsilon0B <- 0.00
#fAɂΗ
epsilon1A <- 0.06
#fBɂΗ
epsilon1B <- 0.02
#fA̎Rx
dA <- 22
#fB̎Rx
dB <- 18
#W{
nobs <- 200
#LӐ
a <- 0.05

findRMSEApowernested(rmsea0A=epsilon0A,
rmsea0B=epsilon0B,rmsea1A=epsilon1A,
rmsea1B=epsilon1B,dfA=dA, dfB=dB, 
n=nobs,alpha=a)
############################################


#lXgfɂW{̎Zo
################################################
p <- 0.8

findRMSEAsamplesizenested(rmsea0A=epsilon0A,
rmsea0B=epsilon0B,rmsea1A=epsilon1A,
rmsea1B=epsilon1B,dfA=dA, dfB=dB, 
power=p,alpha=a)
################################################

#lXgfɂ錟͊֐̕`
################################################
nl <- 50
nh <- 500

plotRMSEApowernested(rmsea0A=epsilon0A,
rmsea0B=epsilon0B,rmsea1A=epsilon1A,
rmsea1B=epsilon1B,dfA=dA, dfB=dB, 
nlow=nl, nhigh=nh, alpha=a)
################################################

#̕
################################################
library(semTools)
#ARMSEA
epsilon0 <- 0.00
#ΗRMSEA
epsilon1 <- 0.05
#W{
nobs <- 200
#f̎Rx
d <- 22
#LӐ
a <- 0.05

findRMSEApower(rmsea0=epsilon0,rmseaA=epsilon1,
n=nobs,df=d,alpha=a)
################################################

p <- 0.8
findRMSEAsamplesize(rmsea0=epsilon0,
rmseaA=epsilon1,pow=p,df=d,alpha=a)
